#include <cstdlib>
#include "calibration.hh"
#include "units.h"

using namespace boost::numeric;
using namespace mimas;

calibration::calibration( const xml_reference< XalanElement >
                          &calibration_node ) throw (mimasexception):
  steps( 0 )
{
  width = atoi( calibration_node.selectNode( "image-size/x" ).
                getNodeText().c_str() );
  height = atoi( calibration_node.selectNode( "image-size/y" ).
                 getNodeText().c_str() );

  pixel_size = atof( calibration_node.selectNode( "pixel-size" ).
                     getNodeText().c_str() ) * MICROMETER;
  focus_distance = atof( calibration_node.selectNode( "focus-distance" ).
                         getNodeText().c_str() ) * MICROMETER;

  if ( calibration_node.existNode( "focus-drive" ) ) {
    focus_shift =
      atof( calibration_node.selectNode( "focus-drive/focus-shift" ).
            getNodeText().c_str() ) * MICROMETER;
    scale_change =
      atof( calibration_node.selectNode( "focus-drive/scale-change" ).
            getNodeText().c_str() );
  } else {
    focus_shift = 0.0 * MICROMETER;
    scale_change = 0.0;
  };
}
