#ifndef __BOUNDED_HOUGH_PLUGIN_HH
#define __BOUNDED_HOUGH_PLUGIN_HH

#include <map>
#include "hough_table.hh"
#include "recognition_method_4dof.hh"

///
class bounded_hough_plugin: public recognition_method_4dof {
public:
  ///
  bounded_hough_plugin( const calibration_ptr &_calib,
                        const mimas::xml_reference< XalanElement >
                        &configuration,
                        bool _verbose );
  ///
  virtual std::vector< match > recognise
  ( const mimas::image< unsigned char > &image,
    double timestamp,
    mi_scene_ptr scene ) const;
protected:
  ///
  int fringe;
  ///
  int sampling_rate;
  ///
  short int min_gradient;
  ///
  std::map< std::string, hough_table_ptr > models;
};

#endif
