#include "geometric_map_xyz.hh"

using namespace boost::numeric;
using namespace mimas;
using namespace std;

rand_function< int > geometric_map_xyz::rnd;

geometric_map_xyz::geometric_map_xyz( xml_reference< XalanElement >
                                      &configuration, bool _verbose ):
  geometric_map( "xyz" ), verbose(_verbose)
{
}

vector< mi_pose > geometric_map_xyz::candidates
   ( const vector< ublas::vector< int > > &features ) const
{
  vector< mi_pose > retVal;

  // Iterate through all points.
  for ( vector< ublas::vector< int > >::const_iterator p = features.begin();
        p != features.end(); p++ )
    retVal.push_back( point_to_pose( *p ) );

  return retVal;
};

bool geometric_map_xyz::random_poses
   ( const vector< ublas::vector< int > > &features,
     mi_pose &pose ) const
{
  const ublas::vector< int > *p( &features[ rnd( features.size() ) ] );
      
  pose = point_to_pose( *p );

  return true;
}

mi_pose geometric_map_xyz::point_to_pose( const ublas::vector< int > &p )
  const
{
  return mi_pose( 0.0, p[0], p[1] ).inv();
}
