#ifndef __HOUGH_TRACKING_DATA_HH
#define __HOUGH_TRACKING_DATA_HH

#include "instance_data.hh"

/// Internal micro-object-related data of hough-tracking.
class hough_tracking_data: public instance_data
{
 public:
  /// Constructor.
  hough_tracking_data( int nb_thresh_failed ):
    nb_thresh_failed(nb_thresh_failed) {}
  ///
  int get_nb_thresh_failed(void) const { return nb_thresh_failed; }
 protected:
  /// Number of tracking-failures.
  int nb_thresh_failed;
};

///
typedef boost::shared_ptr< hough_tracking_data > hough_tracking_data_ptr;

#endif
