#ifndef __TOOLS_TCC
#define __TOOLS_TCC

#include <fstream>
#include <fftw3.h>
#include <mimas/image_fileinput.h>
#include <mimas/image_op.h>
#include "tools.hh"

template< typename T >
mimas::image< T > multi_array_to_image
   ( const boost::multi_array< T, 2 > &x )
{
  mimas::image< T > retVal; retVal.init( x.shape()[ 1 ], x.shape()[ 0 ] );
  retVal.rawData() = x;
  return retVal;
}

template< typename T >
boost::multi_array< T, 2 > image_to_multi_array
   ( const mimas::image< T > &x )
{
  return x.rawData();
}

template< typename T >
mimas::image< T > load_image( const std::string &fileName ) {
  mimas::image< unsigned char > image;
  std::ifstream file( fileName.c_str(), std::ios::binary );
  MMERROR( file >> image, mimas::mimasexception, ,
           "Error loading file \"" << fileName << "\"." );
  return image;
};

#endif
